#!/usr/bin/env node
// Generated by CoffeeScript 1.9.3
(function() {
  var WSS, args, config, cxs, echo, handler, optimist, print, wss;

  config = {
    port: "7441",
    host: "localhost"
  };

  optimist = require("optimist");

  args = optimist.usage("Usage: $0 [--port=PORT] [--host=ADDRESS]").alias("h", "help")["default"]("port", config.port)["default"]("host", config.host).argv;

  if (args.help) {
    optimist.showHelp();
    process.exit(0);
  }

  print = require('sys').print;

  echo = function(msg) {
    return print(msg + "\n");
  };

  WSS = require("ws").Server;

  wss = new WSS({
    port: args.port,
    host: args.host
  });

  cxs = [];

  handler = function(msg) {
    var errors, i, j, len, ref, results;
    echo(msg.split(/\s+/).map(decodeURIComponent).join(" "));
    errors = [];
    cxs.forEach(function(cx, i) {
      var error;
      try {
        return cx.send(msg);
      } catch (_error) {
        error = _error;
        return errors.push(i);
      }
    });
    ref = errors.reverse();
    results = [];
    for (j = 0, len = ref.length; j < len; j++) {
      i = ref[j];
      results.push(cxs.splice(i, 1));
    }
    return results;
  };

  wss.on("connection", function(ws) {
    cxs.push(ws);
    return ws.on("message", handler);
  });

}).call(this);
